import websocket
import json
import threading
import time
import requests
import colorama
from colorama import Fore
import logging
import asyncio


colorama.init()


def send_json_request(ws, request):
    ws.send(json.dumps(request))


def recieve_json_response(ws):
    response = ws.recv()
    if response:
        return json.loads(response)


def heartbeat(interval, ws):
    while True:
        time.sleep(interval)
        heartbeatJSON = {
            "op": 1,
            "d": "null"
        }
        send_json_request(ws, heartbeatJSON)


class Status:
    def __init__(self, presence, status_type=None, status_description=None):
        self.presence = presence
        self.sdesc = status_description
        if status_type.lower() == 'playing':
            self.stype = 0
        if status_type.lower() == 'listening':
            self.stype = 2
        if status_type.lower() == 'watching':
            self.stype = 3


class Embed:

    def __init__(self):
        self.main = {
            'title': None,
            'description': None,
            'color': None,
            "footer": {
                "icon_url": None,
                "text": None
            },
            "thumbnail": {
                "url": None
            },
            "author": {
                "name": None,
                "url": None
            },
            "fields": []
        }

    def set_main(self, title=None, description=None, color=None):
        self.main['title'] = title
        self.main['description'] = description
        self.main['color'] = color

    def set_footer(self, icon_url=None, text=None):
        self.main['footer']['icon_url'] = icon_url
        self.main['footer']['text'] = text

    def set_thumbnail(self, thumbnail=None):
        self.main['thumbnail']['url'] = thumbnail

    def set_author(self, author_name=None, author_url=None):
        self.main['author']['name'] = author_name
        self.main['author']['url'] = author_url

    def add_field(self, name, value, inline=False):
        self.field_test = {
            'name': name,
            'value': value,
            'inline': inline
        }
        self.main['fields'].append(self.field_test)


class Bot():
    # changed __init__
    def __init__(self, token, bot_id):
        self.secret = token
        self.ready_func = None
        self.message_func = None
        self.app_id = bot_id
        self.commands_list = slash_command_storage()
        self.cderrorfunc = None
        self.wait_runners = 0
        self.runners = {}

        # self.recived_b_or_s_interaction
        # self.before_recived_b_or_s_interaction

    def start(self, triggers=None, status=None):  # changed this

        ws = websocket.WebSocket()

        ws.connect('wss://gateway.discord.gg/?v=6&encording=json')
        event = recieve_json_response(ws)

        heartbeat_interval = event['d']['heartbeat_interval'] / 1000
        threading.Thread(target=heartbeat, args=(heartbeat_interval, ws)).start()

        threading.Thread(target=manage_cooldowns).start()

        # changed this:
        if isinstance(status, Status):
            self.sname = status.presence
            self.stype = int(status.stype)
            self.sdesc = status.sdesc

        if status == None:
            self.sname = None
            self.stype = None
            self.sdesc = None
        # to here

        payload = {
            'op': 2,
            "d": {
                "token": self.secret,
                "properties": {
                    "$os": "windows",
                    "$browser": "chrome",
                    "$device": 'pc'
                },
                "presence": {
                    "activities": [{
                        "name": self.sdesc,
                        "type": self.stype  # removed int()
                    }],
                    "status": self.sname
                }
            }
        }

        send_json_request(ws, payload)
        self.button_or_select_callback = []
        self.recived_b_or_s_interaction = 0
        self.before_recived_b_or_s_interaction = 0

        # check all this
        while True:
            try:
                event = recieve_json_response(ws)

                # print(event)
                op_code = event['op']
                evt_type = event['t']

                # new
                if evt_type == 'INTERACTION_CREATE' and 'message' in event['d'].keys():
                    self.interaction_obj = callback_machine(int_data=event['d'], int_type="button")
                    self.button_or_select_callback.append(self.interaction_obj)
                    print(self.button_or_select_callback)
                    self.recived_b_or_s_interaction += 1
                    print(self.recived_b_or_s_interaction)

                # all this changed
                if triggers != None:
                    if evt_type in triggers:
                        triggers[evt_type](event['d'])

                if evt_type == 'INTERACTION_CREATE' and 'message' not in event['d'].keys():
                    for keys in self.commands_list.main:
                        if event['d']['data']['name'] in self.commands_list.main[keys]:
                            self.interaction_obj = callback_machine(int_data=event['d'], int_type="command")
                            # added this
                            my_key = keys

                    if event['d']['data']['name'] in cooldowns.bucket:

                        self.cd_key = [event['d']['data']['name']][0]
                        self.cd_iduser = event['d']['member']['user']['id']

                        if self.cd_iduser not in cooldowns.bucket[self.cd_key]:

                            cooldowns.bucket[self.cd_key][self.cd_iduser] = cooldowns.bucket[self.cd_key]['base']

                            # give data/ no cooldown
                            asyncio.run(
                                self.commands_list.main[my_key][event['d']['data']['name']](self.interaction_obj))

                        else:
                            if cooldowns.bucket[self.cd_key][self.cd_iduser] > 0 and self.cderrorfunc == None:
                                self.error_desc = Fore.RED + f'CommandOnCooldown\nInfo: Occured In Command ' + Fore.RESET + Fore.GREEN + \
                                                  event['d']['data'][
                                                      'name'] + Fore.RESET + Fore.CYAN + ' \nTip: Haddle Error with @bot_object.ON_CommandOnCooldown decorator' + Fore.RESET

                                logging.error(self.error_desc)
                            else:
                                self.interaction_obj = callback_machine(int_data=event['d'], int_type="command")

                                self.cdeinfo = {'command': event['d']['data']['name'],
                                                'cooldown': cooldowns.bucket[self.cd_key][self.cd_iduser]}

                                # give data/ yes cooldown error
                                asyncio.run(self.cderrorfunc(self.cdeinfo, self.interaction_obj))

                            # give data/ no cooldown
                            if cooldowns.bucket[self.cd_key][self.cd_iduser] < 1:
                                asyncio.run(
                                    self.commands_list.main[my_key][event['d']['data']['name']](self.interaction_obj))
                    else:
                        threading.Thread(target=asyncio.run(
                            self.commands_list.main[my_key][event['d']['data']['name']](self.interaction_obj))).start()


            except KeyError:
                pass

    def send(self, channelID, message):
        cha_id = str(channelID)

        baseURL = "https://discordapp.com/api/channels/{}/messages".format(cha_id)
        headers = {"Authorization": "Bot {}".format(self.secret),
                   "Content-Type": "application/json", }

        if isinstance(message, Embed):
            to_send = {"embeds": [message.main]}
        else:
            to_send = {'content': message}

        POSTedJSON = json.dumps(to_send)

        requests.post(baseURL, headers=headers, data=POSTedJSON)

    def reaction(self, channelID, messageID, emoji_word, action):
        uni_emoji = emoji_word
        cha_id = str(channelID)
        msg_id = str(messageID)
        if action == 'add':
            baseURL = f"https://discordapp.com/api/channels/{cha_id}/messages/{msg_id}/reactions/{uni_emoji}/@me"
            headers = {"Authorization": "Bot {}".format(self.secret),
                       "Content-Type": "application/json", }

            requests.put(baseURL, headers=headers)

    def typing(self, channelID):
        baseURL = f"https://discordapp.com/api/channels/{channelID}/typing"

        headers = {"Authorization": "Bot {}".format(self.secret),
                   "Content-Type": "application/json", }

        requests.post(baseURL, headers=headers)

    def pins(self, channelID, action, messageID=None):

        baseURL = f"https://discordapp.com/api/channels/{channelID}/pins"

        headers = {"Authorization": "Bot {}".format(self.secret),
                   "Content-Type": "application/json", }

        if action == 'list':
            r = requests.get(baseURL, headers=headers)
            return r.text

        if action == 'pin':
            baseURL = baseURL + f'/{messageID}'
            requests.put(baseURL, headers=headers)
        if action == 'unpin':
            baseURL = baseURL + f'/{messageID}'
            r = requests.delete(baseURL, headers=headers)


    def command(self, *args, **kwargs):
        def wrapper(slh_cmd_func):

            if 'guild_id' in kwargs:

                baseURL = f"https://discord.com/api/applications/{self.app_id}/guilds/{kwargs['guild_id']}/commands"

                headers = {"Authorization": "Bot {}".format(self.secret),
                           "Content-Type": "application/json", }

                json = {
                    "name": slh_cmd_func.__name__,
                    "type": 1,
                    "description": kwargs['description'],
                }

                requests.post(baseURL, headers=headers, json=json)
                self.commands_list.add(slh_cmd_func.__name__, slh_cmd_func, guild_id=kwargs['guild_id'])


            else:
                url = f"https://discord.com/api/applications/{self.app_id}/commands"

                headers = {"Authorization": "Bot {}".format(self.secret),
                           "Content-Type": "application/json", }

                json = {
                    "name": slh_cmd_func.__name__,
                    "type": 1,
                    "description": kwargs['description'],
                }

                requests.post(url, headers=headers, json=json)

                self.commands_list.add(slh_cmd_func.__name__, slh_cmd_func, guild_id='global')
            return slh_cmd_func

        return wrapper

    def ON_CommandOnCooldown(self, func):
        self.cderrorfunc = func


class slash_command_storage:
    def __init__(self):
        self.main = {}

    def add(self, name, function, guild_id=None):
        if guild_id in self.main.keys():
            self.main[guild_id][name] = function
        else:
            self.main[guild_id] = {}
            self.main[guild_id][name] = function


class ButtonClass:
    def __init__(self, data):
        self.id = data['custom_id']


class callback_machine:
    def __init__(self, int_data, int_type):
        self.token = int_data['token']
        self.id = int_data['id']
        if int_type == 'button':
            self.my_type = 'button'
            self.button = ButtonClass(int_data['data'])
        else:
            self.my_type = 'command'

    def respond(self, message, message_components=None):
        """
        Used to respond to a slash command interaction

        :param message: the message contents to send, can be message or embed object
        :param message_components: Components object to send along with the message.
        :return: None
        """
        url = f"https://discord.com/api/interactions/{self.id}/{self.token}/callback"
        # changed this

        if isinstance(message, Embed):
            json = {
                "type": 4,
                "data": {
                    "embeds": [message.main],
                }
            }
        else:
            json = {
                "type": 4,
                "data": {
                    "content": message,
                }
            }

        if isinstance(message_components, components):
            json['data']['components'] = message_components.main

        requests.post(url, json=json)



class cooldowns:

    @staticmethod
    def set(cooldown_time="seconds of cooldown"):
        def cool_wrapper(cfunc):
            try:
                cooldowns.bucket[cfunc.__name__] = {'base': cooldown_time}
            except AttributeError:
                cooldowns.bucket = {}
                cooldowns.bucket[cfunc.__name__] = {'base': cooldown_time}

        return cool_wrapper


def manage_cooldowns():
    try:

        global cooldowns
        while True:
            time.sleep(1)
            for keys in cooldowns.bucket:
                for cd in cooldowns.bucket[keys]:
                    if cd != 'base':
                        if cooldowns.bucket[keys][cd] > 0:
                            cooldowns.bucket[keys][cd] -= 1
    except AttributeError:
        cooldowns.bucket = {}



class components:


    def __init__(self):
        """
        Represents a component object which can be sent in
        a message with the message_componetents parameter in resonding to a interaction
        such as slash commands
        """
        self.current = 0
        self.main = [{
            "type": 1,
            "components": []
        }]

    def add_button(self, button_label, button_color, button_id, inline=True):
        """
        Method used to add buttons to a component object


        :param button_label: The message displayed on the button
        :param button_color: The color for the button (blue, grey, green, red)
        :param button_id: A unique id for this button, which will be used to respond to a interaction
        :param inline: If the button will be in a new line or the same line as the previous button added.
        :return: None
        """

        if button_color.lower() == 'blue':
            self.button_color = 1
        if button_color.lower() == 'grey':
            self.button_color = 2
        if button_color.lower() == 'green':
            self.button_color = 3
        if button_color.lower() == 'red':
            self.button_color = 4

        self.temp = {
            "type": 2,
            "label": button_label,
            "style": self.button_color,
            "custom_id": button_id
        }

        if inline == True:
            self.main[self.current]['components'].append(self.temp)
        elif inline == False:
            self.main.append(
                {
                    "type": 1,
                    "components": []
                }
            )

            self.current += 1
            self.main[self.current]['components'].append(self.temp)
